stash: drop superfluos pathspec parameter
[git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6    or: $dashless show [<stash>]
7    or: $dashless drop [-q|--quiet] [<stash>]
8    or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9    or: $dashless branch <branchname> [<stash>]
10    or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11                       [-u|--include-untracked] [-a|--all] [<message>]
12    or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13                        [-u|--include-untracked] [-a|--all] [-m <message>]
14                        [-- <pathspec>...]]
15    or: $dashless clear"
16
17 SUBDIRECTORY_OK=Yes
18 OPTIONS_SPEC=
19 START_DIR=$(pwd)
20 . git-sh-setup
21 require_work_tree
22 prefix=$(git rev-parse --show-prefix) || exit 1
23 cd_to_toplevel
24
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28
29 ref_stash=refs/stash
30
31 if git config --get-colorbool color.interactive; then
32        help_color="$(git config --get-color color.interactive.help 'red bold')"
33        reset_color="$(git config --get-color '' reset)"
34 else
35        help_color=
36        reset_color=
37 fi
38
39 no_changes () {
40         git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41         git diff-files --quiet --ignore-submodules -- "$@" &&
42         (test -z "$untracked" || test -z "$(untracked_files "$@")")
43 }
44
45 untracked_files () {
46         if test "$1" = "-z"
47         then
48                 shift
49                 z=-z
50         else
51                 z=
52         fi
53         excl_opt=--exclude-standard
54         test "$untracked" = "all" && excl_opt=
55         git ls-files -o $z $excl_opt -- "$@"
56 }
57
58 clear_stash () {
59         if test $# != 0
60         then
61                 die "$(gettext "git stash clear with parameters is unimplemented")"
62         fi
63         if current=$(git rev-parse --verify --quiet $ref_stash)
64         then
65                 git update-ref -d $ref_stash $current
66         fi
67 }
68
69 create_stash () {
70         stash_msg=
71         untracked=
72         while test $# != 0
73         do
74                 case "$1" in
75                 -m|--message)
76                         shift
77                         stash_msg=${1?"BUG: create_stash () -m requires an argument"}
78                         ;;
79                 -u|--include-untracked)
80                         shift
81                         untracked=${1?"BUG: create_stash () -u requires an argument"}
82                         ;;
83                 --)
84                         shift
85                         break
86                         ;;
87                 esac
88                 shift
89         done
90
91         git update-index -q --refresh
92         if no_changes "$@"
93         then
94                 exit 0
95         fi
96
97         # state of the base commit
98         if b_commit=$(git rev-parse --verify HEAD)
99         then
100                 head=$(git rev-list --oneline -n 1 HEAD --)
101         else
102                 die "$(gettext "You do not have the initial commit yet")"
103         fi
104
105         if branch=$(git symbolic-ref -q HEAD)
106         then
107                 branch=${branch#refs/heads/}
108         else
109                 branch='(no branch)'
110         fi
111         msg=$(printf '%s: %s' "$branch" "$head")
112
113         # state of the index
114         i_tree=$(git write-tree) &&
115         i_commit=$(printf 'index on %s\n' "$msg" |
116                 git commit-tree $i_tree -p $b_commit) ||
117                 die "$(gettext "Cannot save the current index state")"
118
119         if test -n "$untracked"
120         then
121                 # Untracked files are stored by themselves in a parentless commit, for
122                 # ease of unpacking later.
123                 u_commit=$(
124                         untracked_files -z "$@" | (
125                                 GIT_INDEX_FILE="$TMPindex" &&
126                                 export GIT_INDEX_FILE &&
127                                 rm -f "$TMPindex" &&
128                                 git update-index -z --add --remove --stdin &&
129                                 u_tree=$(git write-tree) &&
130                                 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
131                                 rm -f "$TMPindex"
132                 ) ) || die "$(gettext "Cannot save the untracked files")"
133
134                 untracked_commit_option="-p $u_commit";
135         else
136                 untracked_commit_option=
137         fi
138
139         if test -z "$patch_mode"
140         then
141
142                 # state of the working tree
143                 w_tree=$( (
144                         git read-tree --index-output="$TMPindex" -m $i_tree &&
145                         GIT_INDEX_FILE="$TMPindex" &&
146                         export GIT_INDEX_FILE &&
147                         git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
148                         git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
149                         git write-tree &&
150                         rm -f "$TMPindex"
151                 ) ) ||
152                         die "$(gettext "Cannot save the current worktree state")"
153
154         else
155
156                 rm -f "$TMP-index" &&
157                 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
158
159                 # find out what the user wants
160                 GIT_INDEX_FILE="$TMP-index" \
161                         git add--interactive --patch=stash -- "$@" &&
162
163                 # state of the working tree
164                 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
165                 die "$(gettext "Cannot save the current worktree state")"
166
167                 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
168                 test -s "$TMP-patch" ||
169                 die "$(gettext "No changes selected")"
170
171                 rm -f "$TMP-index" ||
172                 die "$(gettext "Cannot remove temporary index (can't happen)")"
173
174         fi
175
176         # create the stash
177         if test -z "$stash_msg"
178         then
179                 stash_msg=$(printf 'WIP on %s' "$msg")
180         else
181                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
182         fi
183         w_commit=$(printf '%s\n' "$stash_msg" |
184         git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185         die "$(gettext "Cannot record working tree state")"
186 }
187
188 store_stash () {
189         while test $# != 0
190         do
191                 case "$1" in
192                 -m|--message)
193                         shift
194                         stash_msg="$1"
195                         ;;
196                 -q|--quiet)
197                         quiet=t
198                         ;;
199                 *)
200                         break
201                         ;;
202                 esac
203                 shift
204         done
205         test $# = 1 ||
206         die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
207
208         w_commit="$1"
209         if test -z "$stash_msg"
210         then
211                 stash_msg="Created via \"git stash store\"."
212         fi
213
214         git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
215         ret=$?
216         test $ret != 0 && test -z "$quiet" &&
217         die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218         return $ret
219 }
220
221 push_stash () {
222         keep_index=
223         patch_mode=
224         untracked=
225         stash_msg=
226         while test $# != 0
227         do
228                 case "$1" in
229                 -k|--keep-index)
230                         keep_index=t
231                         ;;
232                 --no-keep-index)
233                         keep_index=n
234                         ;;
235                 -p|--patch)
236                         patch_mode=t
237                         # only default to keep if we don't already have an override
238                         test -z "$keep_index" && keep_index=t
239                         ;;
240                 -q|--quiet)
241                         GIT_QUIET=t
242                         ;;
243                 -u|--include-untracked)
244                         untracked=untracked
245                         ;;
246                 -a|--all)
247                         untracked=all
248                         ;;
249                 -m|--message)
250                         shift
251                         test -z ${1+x} && usage
252                         stash_msg=$1
253                         ;;
254                 --help)
255                         show_help
256                         ;;
257                 --)
258                         shift
259                         break
260                         ;;
261                 -*)
262                         option="$1"
263                         # TRANSLATORS: $option is an invalid option, like
264                         # `--blah-blah'. The 7 spaces at the beginning of the
265                         # second line correspond to "error: ". So you should line
266                         # up the second line with however many characters the
267                         # translation of "error: " takes in your language. E.g. in
268                         # English this is:
269                         #
270                         #    $ git stash save --blah-blah 2>&1 | head -n 2
271                         #    error: unknown option for 'stash save': --blah-blah
272                         #           To provide a message, use git stash save -- '--blah-blah'
273                         eval_gettextln "error: unknown option for 'stash save': \$option
274        To provide a message, use git stash save -- '\$option'"
275                         usage
276                         ;;
277                 *)
278                         break
279                         ;;
280                 esac
281                 shift
282         done
283
284         eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
285
286         if test -n "$patch_mode" && test -n "$untracked"
287         then
288                 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
289         fi
290
291         test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
292
293         git update-index -q --refresh
294         if no_changes "$@"
295         then
296                 say "$(gettext "No local changes to save")"
297                 exit 0
298         fi
299
300         git reflog exists $ref_stash ||
301                 clear_stash || die "$(gettext "Cannot initialize stash")"
302
303         create_stash -m "$stash_msg" -u "$untracked" -- "$@"
304         store_stash -m "$stash_msg" -q $w_commit ||
305         die "$(gettext "Cannot save the current status")"
306         say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
307
308         if test -z "$patch_mode"
309         then
310                 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
311                 if test -n "$untracked" && test $# = 0
312                 then
313                         git clean --force --quiet -d $CLEAN_X_OPTION
314                 fi
315
316                 if test $# != 0
317                 then
318                         test -z "$untracked" && UPDATE_OPTION="-u" || UPDATE_OPTION=
319                         test "$untracked" = "all" && FORCE_OPTION="--force" || FORCE_OPTION=
320                         git add $UPDATE_OPTION $FORCE_OPTION -- "$@"
321                         git diff-index -p --cached --binary HEAD -- "$@" |
322                         git apply --index -R
323                 else
324                         git reset --hard -q
325                 fi
326
327                 if test "$keep_index" = "t" && test -n "$i_tree"
328                 then
329                         git read-tree --reset $i_tree
330                         git ls-files -z --modified -- "$@" |
331                         git checkout-index -z --force --stdin
332                 fi
333         else
334                 git apply -R < "$TMP-patch" ||
335                 die "$(gettext "Cannot remove worktree changes")"
336
337                 if test "$keep_index" != "t"
338                 then
339                         git reset -q -- "$@"
340                 fi
341         fi
342 }
343
344 save_stash () {
345         push_options=
346         while test $# != 0
347         do
348                 case "$1" in
349                 --)
350                         shift
351                         break
352                         ;;
353                 -*)
354                         # pass all options through to push_stash
355                         push_options="$push_options $1"
356                         ;;
357                 *)
358                         break
359                         ;;
360                 esac
361                 shift
362         done
363
364         stash_msg="$*"
365
366         if test -z "$stash_msg"
367         then
368                 push_stash $push_options
369         else
370                 push_stash $push_options -m "$stash_msg"
371         fi
372 }
373
374 have_stash () {
375         git rev-parse --verify --quiet $ref_stash >/dev/null
376 }
377
378 list_stash () {
379         have_stash || return 0
380         git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
381 }
382
383 show_stash () {
384         ALLOW_UNKNOWN_FLAGS=t
385         assert_stash_like "$@"
386
387         if test -z "$FLAGS"
388         then
389                 if test "$(git config --bool stash.showStat || echo true)" = "true"
390                 then
391                         FLAGS=--stat
392                 fi
393
394                 if test "$(git config --bool stash.showPatch || echo false)" = "true"
395                 then
396                         FLAGS=${FLAGS}${FLAGS:+ }-p
397                 fi
398
399                 if test -z "$FLAGS"
400                 then
401                         return 0
402                 fi
403         fi
404
405         git diff ${FLAGS} $b_commit $w_commit
406 }
407
408 show_help () {
409         exec git help stash
410         exit 1
411 }
412
413 #
414 # Parses the remaining options looking for flags and
415 # at most one revision defaulting to ${ref_stash}@{0}
416 # if none found.
417 #
418 # Derives related tree and commit objects from the
419 # revision, if one is found.
420 #
421 # stash records the work tree, and is a merge between the
422 # base commit (first parent) and the index tree (second parent).
423 #
424 #   REV is set to the symbolic version of the specified stash-like commit
425 #   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
426 #   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
427 #   s is set to the SHA1 of the stash commit
428 #   w_commit is set to the commit containing the working tree
429 #   b_commit is set to the base commit
430 #   i_commit is set to the commit containing the index tree
431 #   u_commit is set to the commit containing the untracked files tree
432 #   w_tree is set to the working tree
433 #   b_tree is set to the base tree
434 #   i_tree is set to the index tree
435 #   u_tree is set to the untracked files tree
436 #
437 #   GIT_QUIET is set to t if -q is specified
438 #   INDEX_OPTION is set to --index if --index is specified.
439 #   FLAGS is set to the remaining flags (if allowed)
440 #
441 # dies if:
442 #   * too many revisions specified
443 #   * no revision is specified and there is no stash stack
444 #   * a revision is specified which cannot be resolve to a SHA1
445 #   * a non-existent stash reference is specified
446 #   * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
447 #
448
449 parse_flags_and_rev()
450 {
451         test "$PARSE_CACHE" = "$*" && return 0 # optimisation
452         PARSE_CACHE="$*"
453
454         IS_STASH_LIKE=
455         IS_STASH_REF=
456         INDEX_OPTION=
457         s=
458         w_commit=
459         b_commit=
460         i_commit=
461         u_commit=
462         w_tree=
463         b_tree=
464         i_tree=
465         u_tree=
466
467         FLAGS=
468         REV=
469         for opt
470         do
471                 case "$opt" in
472                         -q|--quiet)
473                                 GIT_QUIET=-t
474                         ;;
475                         --index)
476                                 INDEX_OPTION=--index
477                         ;;
478                         --help)
479                                 show_help
480                         ;;
481                         -*)
482                                 test "$ALLOW_UNKNOWN_FLAGS" = t ||
483                                         die "$(eval_gettext "unknown option: \$opt")"
484                                 FLAGS="${FLAGS}${FLAGS:+ }$opt"
485                         ;;
486                         *)
487                                 REV="${REV}${REV:+ }'$opt'"
488                         ;;
489                 esac
490         done
491
492         eval set -- $REV
493
494         case $# in
495                 0)
496                         have_stash || die "$(gettext "No stash entries found.")"
497                         set -- ${ref_stash}@{0}
498                 ;;
499                 1)
500                         :
501                 ;;
502                 *)
503                         die "$(eval_gettext "Too many revisions specified: \$REV")"
504                 ;;
505         esac
506
507         case "$1" in
508                 *[!0-9]*)
509                         :
510                 ;;
511                 *)
512                         set -- "${ref_stash}@{$1}"
513                 ;;
514         esac
515
516         REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
517                 reference="$1"
518                 die "$(eval_gettext "\$reference is not a valid reference")"
519         }
520
521         i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
522         set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
523         s=$1 &&
524         w_commit=$1 &&
525         b_commit=$2 &&
526         w_tree=$3 &&
527         b_tree=$4 &&
528         i_tree=$5 &&
529         IS_STASH_LIKE=t &&
530         test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
531         IS_STASH_REF=t
532
533         u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
534         u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
535 }
536
537 is_stash_like()
538 {
539         parse_flags_and_rev "$@"
540         test -n "$IS_STASH_LIKE"
541 }
542
543 assert_stash_like() {
544         is_stash_like "$@" || {
545                 args="$*"
546                 die "$(eval_gettext "'\$args' is not a stash-like commit")"
547         }
548 }
549
550 is_stash_ref() {
551         is_stash_like "$@" && test -n "$IS_STASH_REF"
552 }
553
554 assert_stash_ref() {
555         is_stash_ref "$@" || {
556                 args="$*"
557                 die "$(eval_gettext "'\$args' is not a stash reference")"
558         }
559 }
560
561 apply_stash () {
562
563         assert_stash_like "$@"
564
565         git update-index -q --refresh || die "$(gettext "unable to refresh index")"
566
567         # current index state
568         c_tree=$(git write-tree) ||
569                 die "$(gettext "Cannot apply a stash in the middle of a merge")"
570
571         unstashed_index_tree=
572         if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
573                         test "$c_tree" != "$i_tree"
574         then
575                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
576                 test $? -ne 0 &&
577                         die "$(gettext "Conflicts in index. Try without --index.")"
578                 unstashed_index_tree=$(git write-tree) ||
579                         die "$(gettext "Could not save index tree")"
580                 git reset
581         fi
582
583         if test -n "$u_tree"
584         then
585                 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
586                 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
587                 rm -f "$TMPindex" ||
588                 die "$(gettext "Could not restore untracked files from stash entry")"
589         fi
590
591         eval "
592                 GITHEAD_$w_tree='Stashed changes' &&
593                 GITHEAD_$c_tree='Updated upstream' &&
594                 GITHEAD_$b_tree='Version stash was based on' &&
595                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
596         "
597
598         if test -n "$GIT_QUIET"
599         then
600                 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
601         fi
602         if git merge-recursive $b_tree -- $c_tree $w_tree
603         then
604                 # No conflict
605                 if test -n "$unstashed_index_tree"
606                 then
607                         git read-tree "$unstashed_index_tree"
608                 else
609                         a="$TMP-added" &&
610                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
611                         git read-tree --reset $c_tree &&
612                         git update-index --add --stdin <"$a" ||
613                                 die "$(gettext "Cannot unstage modified files")"
614                         rm -f "$a"
615                 fi
616                 squelch=
617                 if test -n "$GIT_QUIET"
618                 then
619                         squelch='>/dev/null 2>&1'
620                 fi
621                 (cd "$START_DIR" && eval "git status $squelch") || :
622         else
623                 # Merge conflict; keep the exit status from merge-recursive
624                 status=$?
625                 git rerere
626                 if test -n "$INDEX_OPTION"
627                 then
628                         gettextln "Index was not unstashed." >&2
629                 fi
630                 exit $status
631         fi
632 }
633
634 pop_stash() {
635         assert_stash_ref "$@"
636
637         if apply_stash "$@"
638         then
639                 drop_stash "$@"
640         else
641                 status=$?
642                 say "$(gettext "The stash entry is kept in case you need it again.")"
643                 exit $status
644         fi
645 }
646
647 drop_stash () {
648         assert_stash_ref "$@"
649
650         git reflog delete --updateref --rewrite "${REV}" &&
651                 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
652                 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
653
654         # clear_stash if we just dropped the last stash entry
655         git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
656         clear_stash
657 }
658
659 apply_to_branch () {
660         test -n "$1" || die "$(gettext "No branch name specified")"
661         branch=$1
662         shift 1
663
664         set -- --index "$@"
665         assert_stash_like "$@"
666
667         git checkout -b $branch $REV^ &&
668         apply_stash "$@" && {
669                 test -z "$IS_STASH_REF" || drop_stash "$@"
670         }
671 }
672
673 test "$1" = "-p" && set "push" "$@"
674
675 PARSE_CACHE='--not-parsed'
676 # The default command is "push" if nothing but options are given
677 seen_non_option=
678 for opt
679 do
680         case "$opt" in
681         --) break ;;
682         -*) ;;
683         *) seen_non_option=t; break ;;
684         esac
685 done
686
687 test -n "$seen_non_option" || set "push" "$@"
688
689 # Main command set
690 case "$1" in
691 list)
692         shift
693         list_stash "$@"
694         ;;
695 show)
696         shift
697         show_stash "$@"
698         ;;
699 save)
700         shift
701         save_stash "$@"
702         ;;
703 push)
704         shift
705         push_stash "$@"
706         ;;
707 apply)
708         shift
709         apply_stash "$@"
710         ;;
711 clear)
712         shift
713         clear_stash "$@"
714         ;;
715 create)
716         shift
717         create_stash -m "$*" && echo "$w_commit"
718         ;;
719 store)
720         shift
721         store_stash "$@"
722         ;;
723 drop)
724         shift
725         drop_stash "$@"
726         ;;
727 pop)
728         shift
729         pop_stash "$@"
730         ;;
731 branch)
732         shift
733         apply_to_branch "$@"
734         ;;
735 *)
736         case $# in
737         0)
738                 push_stash &&
739                 say "$(gettext "(To restore them type \"git stash apply\")")"
740                 ;;
741         *)
742                 usage
743         esac
744         ;;
745 esac